/*---------------------------------------------------------------------------*
  Project:	NITRO-System - build - demos - g3d - samples - RecordMaterial
  File:     main.c

  Copyright 2004,2005 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: main.c,v $
  Revision 1.6  02/25/2005 03:11:00  takano_makoto
  Warning measures for signed<->unsigned casts

  Revision 1.5  11/12/2004 05:40:32  nishida
  Revised project name of file header.

  Revision 1.4  11/04/2004 10:43:25  nishida
  Fixed function header of SetCamera function.

  Revision 1.3  09/10/2004 09:53:13  nishida_kenji
  rename NNS_G3dGlbFlush to NNS_G3dGlbFlushP.

  Revision 1.2  08/31/2004 05:11:40  nishida_kenji
  small fix

  Revision 1.1  08/04/2004 11:16:33  nishida_kenji
  Initial check in.

  $NoKeywords: $
 *---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------
//
// Sample of pre-calculating material calculation results
//
// By buffering the material calculation results, you can reduce the CPU calculation cost
// when the material does not change.
//
// Sample Operation
// Joint animation is played repeatedly.
// Pushing the A button switches between using the buffered material calculation results, or
// recalculating with each draw.
//
// HOWTO:
// 1: Secure buffer region with NNS_G3dAllocRecBufferMat.
// 2: Attach the buffer to the rendering object using
//    NNS_G3dRenderObjSetMatAnmBuffer.
// 3: Enable NNS_G3D_RENDEROBJ_FLAG_RECORD with NNS_G3dRenderObjSetFlag.
//    When you call with this flag enabled, the calculation results are stored in the buffer.
// 4: Also, when you enable NNS_G3D_RENDEROBJ_FLAG_NOGECMD, data is not transmitted to the
//    geometry engine when executing NNS_G3dDraw.
// 5: Execute NNS_G3dDraw and sstore the data in the buffer.
// 6: Reset NNS_G3D_RENDEROBJ_FLAG_RECORD and (NNS_G3D_RENDEROBJ_FLAG_NOGECMD)
//    with NNS_G3dRenderObjResetFlag.
// 7: Instead of calculating material data from NNS_G3dDraw next time, reference buffer data and draw.
// 8: You can disconnect the buffer with NNS_G3dRenderObjReleaseMatAnmBuffer.
//
//---------------------------------------------------------------------------

#include "g3d_demolib.h"

G3DDemoCamera gCamera;        // Camera structure.
G3DDemoGround gGround;        // Ground structure.

static void          InitG3DLib(void);
static NNSG3dResMdl* LoadG3DModel(const char* path);
static void          SetCamera(G3DDemoCamera* camera);


/* -------------------------------------------------------------------------
  Name:         NitroMain

  Description:  Sample main.

  Arguments:    None.

  Returns:      None.
   ------------------------------------------------------------------------- */
void
NitroMain(void)
{
    NNSG3dRenderObj object;
    NNSG3dResMdl*   pModel;
    void*           pAnmRes;
    NNSFndAllocator allocator;
    NNSG3dAnmObj*   pAnmObj;
    NNSG3dMatAnmResult* pBufMatAnmResult;
    BOOL useRecord = TRUE;

    G3DDemo_InitSystem();
    G3DDemo_InitMemory();
    G3DDemo_InitVRAM();

    InitG3DLib();
    G3DDemo_InitDisplay();

    //
    // create allocator with 4-byte alignment
    //
    NNS_FndInitAllocatorForExpHeap(&allocator, G3DDemo_AppHeap, 4);

    // Makes the manager able to manage 4 slots of texture image slots,
    // and sets to the default manager.
    NNS_GfdInitFrmTexVramManager(4, TRUE);

    // Makes the manager able to manage 32 KB of palettes,
    // and sets to the default manager.
    NNS_GfdInitFrmPlttVramManager(0x8000, TRUE);

    pModel = LoadG3DModel("data/envelope_simple.nsbmd");
    SDK_ASSERTMSG(pModel, "load failed");

    //
    // G3D: NNSG3dRenderObj initialization
    //
    // NNSG3dRenderObj is a structure that holds every type of information relating to one model and
    // animation applied to that model.
    // The area specified by the internal member pointer must be obtained and released by the user.
    // Here mdl can be NULL. (It must be set during NNS_G3dDraw.)
    //
    NNS_G3dRenderObjInit(&object, pModel);
    
    //
    // Load the joint animation and try making associations.
    //
    {
        const u8* pFile = G3DDemo_LoadFile("data/envelope_simple.nsbca");
        SDK_ASSERTMSG( pFile, "anm load failed" );
        {
            // initialize animation, add to rendering object
            // 
            // Allocate and initialize the animation object (NNSG3dAnmObj) that goes between
            // the loaded animation file and NNSG3dRenderObj.
            // All animation is set up with the same code.
            //

            //
            // Allocates from the allocator the memory necessary for the animation object.
            // You must specify and allocate model resources and animation resources.
            //

            // specify index #0 animation
            pAnmRes = NNS_G3dGetAnmByIdx(pFile, 0);
            SDK_NULL_ASSERT(pAnmRes);

            // Allocates the necessary amount of memory. Initialize must be separate.
            pAnmObj = NNS_G3dAllocAnmObj(&allocator, // specify the allocator to use
                                         pAnmRes,    // specify animation resource
                                         pModel);    // specify model resource
            SDK_NULL_ASSERT(pAnmObj);

            //
            // Initialize AnmObj. Same for others that are not joint animation
            //
            NNS_G3dAnmObjInit(pAnmObj, // pointer to animation object
                              pAnmRes, // pointer to animation resource
                              pModel,  // pointer to NNSG3dResMdl
                              NULL );  // pointer to NNSG3dResTex (NULL is OK except for texture pattern animation)

            //
            // Add AnmObj to RenderObj. Same for others that are not joint animation
            //
            NNS_G3dRenderObjAddAnmObj( &object, pAnmObj );
        }

        {
            //
            // Secure material calculation result buffer and attach to rendering object.
            //
            pBufMatAnmResult = NNS_G3dAllocRecBufferMat(&allocator, pModel);
            NNS_G3dRenderObjSetMatAnmBuffer(&object, pBufMatAnmResult);

            //
            // Register material calculation results to buffer.
            //
            NNS_G3dRenderObjSetFlag(&object, NNS_G3D_RENDEROBJ_FLAG_NOGECMD); // do not send to geometry engine
            NNS_G3dRenderObjSetFlag(&object, NNS_G3D_RENDEROBJ_FLAG_RECORD);  // register data in pBufMatAnmResult

            NNS_G3dDraw(&object);

            NNS_G3dRenderObjResetFlag(&object, NNS_G3D_RENDEROBJ_FLAG_NOGECMD); // send to geometry engine
            NNS_G3dRenderObjResetFlag(&object, NNS_G3D_RENDEROBJ_FLAG_RECORD);  // use pBufMatAnmResult data
        }

    }
    
    //
    // demo common initialization
    //
    G3DDemo_InitCamera(&gCamera, 2*FX32_ONE, 10*FX32_ONE);
    G3DDemo_InitGround(&gGround, (fx32)(1.5*FX32_ONE));

    G3DDemo_InitConsole();
    G3DDemo_Print(0,0, G3DDEMO_COLOR_YELLOW, "RecordMaterial");

    for(;;)
    {
        OSTick time;

        SVC_WaitVBlankIntr();


        G3DDemo_PrintApplyToHW();
        G3DDemo_ReadGamePad();

        G3DDemo_MoveCamera(&gCamera);
        G3DDemo_CalcCamera(&gCamera);

        G3X_Reset();
        G3X_ResetMtxStack();

        SetCamera(&gCamera);

        //
        // Update animation frame.
        //
        pAnmObj->frame += FX32_ONE;
        if( pAnmObj->frame >= NNS_G3dAnmObjGetNumFrame(pAnmObj))
        {
            pAnmObj->frame = 0;
        }

        if (G3DDEMO_IS_PAD_TRIGGER(PAD_BUTTON_A))
        {
            if (useRecord)
            {
                useRecord = FALSE;
                (void)NNS_G3dRenderObjReleaseMatAnmBuffer(&object);
            }
            else
            {
                useRecord = TRUE;
                NNS_G3dRenderObjSetMatAnmBuffer(&object, pBufMatAnmResult);
            }
        }

        if (useRecord)
        {
            G3DDemo_Printf(0, 2, G3DDEMO_COLOR_GREEN, "use recorded material data    ");
        }
        else
        {
            G3DDemo_Printf(0, 2, G3DDEMO_COLOR_GREEN, "calc material data every frame");
        }

        {
            VecFx32 scale = { FX32_ONE>>2, FX32_ONE>>2, FX32_ONE>>2 };
            NNS_G3dGlbSetBaseScale(&scale);
            //
            // G3D:
            // Collects and transfers the state set with G3dGlbXXXX.
            // Camera and projection matrix, and the like, are set.
            //
            NNS_G3dGlbFlushP();

            //  Start time measurement
            time = OS_GetTick();
            //
            // G3D: NNS_G3dDraw
            // Performs drawing for all instances by passing the
            // NNSG3dRenderObj that was set up.
            //
            NNS_G3dDraw(&object);

            time = OS_GetTick() - time;
        }

        {
            VecFx32 scale = {FX32_ONE, FX32_ONE, FX32_ONE};
            NNS_G3dGlbSetBaseScale(&scale);
            //
            // G3D: Before calling normal G3_XXX, NNS_G3dGeComFlushBuffer()
            //      must be called and synchronized
            //
            NNS_G3dGlbFlushP();
            NNS_G3dGeFlushBuffer();
            G3DDemo_DrawGround(&gGround);
        }

        /* memory swap relating to geometry and rendering engine*/
        G3_SwapBuffers(GX_SORTMODE_AUTO, GX_BUFFERMODE_W);

        //
        // Time measurement results screen display.
        //
        G3DDemo_Printf(16,0, G3DDEMO_COLOR_YELLOW, "TIME:%06ld usec", OS_TicksToMicroSeconds(time));
    }
}


/* -------------------------------------------------------------------------
  Name:         InitG3DLib

  Description:  Initializes G3D library.

  Arguments:    None.

  Returns:      None.
   ------------------------------------------------------------------------- */
static void
InitG3DLib(void)
{
    //
    // G3D:
    // performs default initialization
    // ------------------------------------------------------------------------
    NNS_G3dInit();
}


/* -------------------------------------------------------------------------
  Name:         LoadG3DModel

  Description:  Reads model data from file.

  Arguments:    path: Model data path name.

  Returns:      Pointer to model.
   ------------------------------------------------------------------------- */
static NNSG3dResMdl*
LoadG3DModel(const char* path)
{
    NNSG3dResMdl*        model   = NULL;
    NNSG3dResTex*        texture = NULL;
    NNSG3dResFileHeader* resFile = G3DDemo_LoadFile(path);
    BOOL status;

    SDK_NULL_ASSERT(resFile);

    status = NNS_G3dResDefaultSetup(resFile);
    NNS_G3D_ASSERTMSG(status, "NNS_G3dResDefaultSetup failed");

    //
    // G3D: get model
    // nsbmd can include multiple models, so sets the index (0 when there is one model)
    // and gets the pointer to the one model.
    // --------------------------------------------------------------------
    model = NNS_G3dGetMdlByIdx(NNS_G3dGetMdlSet(resFile), 0);

    return model;
}


/* -------------------------------------------------------------------------
  Name:         SetCamera

  Description:  Sets camera matrix and projection matrix in G3D global state.

  Arguments:    camera:		pointer to the G3DDemoCamera structure

  Returns:      None.
   ------------------------------------------------------------------------- */
static void
SetCamera(G3DDemoCamera* camera)
{
    G3DDemoLookAt* lookat = &camera->lookat;
    G3DDemoPersp*  persp  = &camera->persp;

    NNS_G3dGlbPerspective(persp->fovySin, persp->fovyCos, persp->aspect, persp->nearClip, persp->farClip);
    NNS_G3dGlbLookAt(&lookat->camPos, &lookat->camUp, &lookat->target);
}

